import { InjectionToken } from '@angular/core';
import { Observable } from 'rxjs';
export declare const BROWSER_LOCAL_STORAGE: InjectionToken<Storage>;
export declare const BROWSER_SESSION_STORAGE: InjectionToken<Storage>;
export declare type BrowserStorageType = 'local' | 'session';
export declare const BROWSER_STORAGE_TYPE_LOCAL: BrowserStorageType;
export declare const BROWSER_STORAGE_TYPE_SESSION: BrowserStorageType;
export declare const BROWSER_STORAGE_TYPES: BrowserStorageType[];
export interface BrowserStorageOptions {
    default?: BrowserStorageType;
    salt?: string;
    obfuscate?: boolean;
}
export declare class BrowserStorageService {
    private readonly localStorage;
    private readonly sessionStorage;
    private storageSubjects;
    private storageStates;
    private storageSubscriptions;
    private options;
    constructor();
    configure(options?: BrowserStorageOptions): this;
    has(key: string, storageType?: BrowserStorageType, doHash?: boolean): boolean;
    keys(storageType?: BrowserStorageType): string[];
    getObserver(key: string, storageType?: BrowserStorageType): Observable<any>;
    get(key: string, storageType?: BrowserStorageType): any;
    getTyped<T>(key: string, storageType?: BrowserStorageType): T;
    set(key: string, value: any, storageType?: BrowserStorageType): void;
    trigger(key: string | string[], storageType?: BrowserStorageType): void;
    remove(key: string, storageType?: BrowserStorageType): void;
    clear(storageType?: BrowserStorageType): void;
    private _init;
    private getIndexKey;
    private getStorageType;
    private getStorage;
    private getFingerprint;
    private hash;
    private encrypt;
    private decrypt;
}
